//------------------------------------
// "the truth is out there"
// 256 bytes exe gfx
// by wacek/arise
//------------------------------------

//------------------------------------
// global compile variables
//------------------------------------

.var raster1 = $6b + 11
.var raster2 = $99 + 11
.var raster3 = $b5 + 11
.var raster4 = $c5 + 11
.var raster5 = $cf + 11
.var raster6 = $d5 + 11
.var raster7 = $db + 11
.var raster8 = $fc

.var c1 = $a0
.var c2 = $a1
.var ra = $a2
.var pack = $a3
.var offset = $a4

.var begin = $0400 + 21 * 40 + 4

//------------------------------------
// main
//------------------------------------

			* = $1000	"main"
		
start:		sei

			lda #0
			sta $d020
			sta $d027
			sta $0286
			sta offset
			jsr $e544

			sta $07f8
			stx $d015
			sty $d000
			sty $d001
			dex
			
!loop:		lda sprite,x
			sta $3600,x
			inx
			cpx #27
			bne !loop-
!loop:		sta $3600,x
			inx
			cpx #64
			bne !loop-

			tay
			tax
			
depack:		lda mountains_packed,x		
			sta pack
			clc
			
			and #%11000000
			jsr depack_ror6

			and #%00110000
			jsr depack_ror4
			
			and #%00001100			
			jsr depack_ror2
			
			and #%00000011			
			jsr depack_ror0
			
			inc offset						
			ldx offset						
			cpx #39						
			bne depack						

main_loop:	

!loop:		cpx $d012
			bne !loop-
			ldx #0
			
rainbow_loop:			
			lda c1_tab,x
			sta c1
			lda c2_tab,x
			sta c2
			lda ra_tab,x
			sta ra

mix_loop:	ldy c1

			lda $d012
!loop:		cmp $d012
			beq !loop-
			sty $d021

			ldy c2

			lda $d012
!loop:		cmp $d012
			beq !loop-
			sty $d021
		
			nop
			bit $ea
			
			lda $d012				
			cmp ra				
			bne mix_loop			

			inx
			cpx #8
			bne rainbow_loop
			
			beq main_loop

c2_tab:		.byte $0d
c1_tab:		.byte $03,$03,$0e,$0e,$04,$04,$06,$06
ra_tab:		.byte raster1,raster2,raster3,raster4,raster5,raster6,raster7,raster8

//------------------------------------
// procedures
//------------------------------------

depack_ror6:
			ror
			ror
depack_ror4:
			ror
			ror
depack_ror2:
			ror
			ror
depack_ror0:
			tax
			lda pack_tab,x
			sta begin,y
			iny
			lda pack
			rts

//------------------------------------
// tables
//------------------------------------

mountains_packed:
			.byte 11,0,0,0,0,0,176,0,44,44,37,236,39,0
			.byte 11,2,92,11,151,151,149,87,149,236,37,121
			.byte 85,229,85,85,85,85,85,87,149,85,85,85,85

pack_tab:	.byte 32,160,233,223

//------------------------------------
// includes
//------------------------------------

sprite:		.import binary "assets\ufo3.map",0,27

//------------------------------------
// all ends here
//------------------------------------